//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

//    
bool checkEven (int elem, bool even)
{
  if (even) {
      return elem % 2 == 0;
  }
  else {
      return elem % 2 == 1;
  }
}


int main()
{
  vector<int> coll;

  INSERT_ELEMENTS(coll,1,9);
  PRINT_ELEMENTS(coll," :\n");

  //  checkEven()
  // -   "  "
  bool checkEvenArgs[3] = { true, false, true };

  //     coll
  vector<int>::iterator pos;
  pos = search (coll.begin(), coll.end(),       // 
                checkEvenArgs, checkEvenArgs+3, //  
                checkEven);                     // 

  //     ,   coll
  //     
  while (pos != coll.end()) {
      //    
      cout << ToRus("     ")
           << distance(coll.begin(),pos) + 1
           << endl;

      //     coll
      pos = search (++pos, coll.end(),              // 
                    checkEvenArgs, checkEvenArgs+3, //  
                    checkEven);                     // 
  }


  getch();
  return 0;
}

//---------------------------------------------------------------------------